backend/controllers/RequestController.php
<?php

namespace backend\controllers;

use app\models\Address;
use app\models\CallRequest;
use backend\models\SearchAddress;
use Yii;
use yii\filters\AccessControl;
use yii\filters\VerbFilter;
use yii\helpers\ArrayHelper;
use yii\helpers\Html;
use yii\web\Controller;
use yii\web\NotFoundHttpException;


/**
 * RequestController implements the CRUD actions for CallRequest model.
 */
class RequestController extends Controller
{
    public function init()
    {		
		//$this->bottstrap_css = true;
		Yii::$app->language = 'ru-RU';
	}
	
    public function behaviors()
    {
        return [
            'access' => [
                'class' => AccessControl::className(),
                'rules' => [
                    [
                        'actions' => ['update'],
                        'allow' => true,
						'roles' => ['request_edit']
                    ],
                    [
                        'actions' => ['done'],
                        'allow' => true,
						'roles' => ['request_done']
                    ],
                    [
                        'actions' => ['index', 'view'],
                        'allow' => true,
						'roles' => ['request_view']
                    ],
                    [
                        'actions' => ['create'],
                        'allow' => true,
						'roles' => ['request_create']
                    ],
                    [
                        'actions' => ['getaddrinp'],
                        'allow' => true,
						//'roles' => ['request_create']
                    ],
                    [
                        'actions' => ['getaddrinp2'],
                        'allow' => true,
						//'roles' => ['request_create']
                    ],
                    [
                        'actions' => ['view-posible-dependency'],
                        'allow' => true,
						//'roles' => ['request_create']
                    ],
                    [
                        'actions' => ['get-sub-crash'],
                        'allow' => true,
						//'roles' => ['request_create']
                    ],
					
                ],
            ],		
            'verbs' => [
                'class' => VerbFilter::className(),
                'actions' => [
                    'delete' => ['post'],
                ],
            ],
        ];
    }

    /**
     * Lists all CallRequest models.
     * @return mixed
     */
    public function actionIndex()
    {
        $searchModel = new RequestSearch();
		$queryParams = Yii::$app->request->queryParams;
		if (!array_key_exists('sort', $queryParams))
		{
			return $this->redirect(['index','sort'=>'-id']);
		}

        $dataProvider = $searchModel->search($queryParams);

        return $this->render('index', [
            'searchModel' => $searchModel,
            'dataProvider' => $dataProvider,
        ]);
    }

	public function actionGetSubCrash($id)
    {
		$a_sub_crash = CallRequest::find()->where(['crash_id'=>$id]);
		$dataProvider = new \yii\data\ActiveDataProvider([
			'query' => $a_sub_crash,
		]);


		return $this->renderPartial('sub_crash_tr', [
            'searchModel' => null,
            'dataProvider' => $dataProvider,
			'only_rec' => true,
        ]);
    }

    /**
     * Displays a single CallRequest model.
     * @param integer $id
     * @return mixed
     */
    public function actionView($id)
    {
        return $this->renderPartial('view', [
            'model' => $this->findModel($id),
        ]);
    }

    /**
     * Creates a new CallRequest model.
     * If creation is successful, the browser will be redirected to the 'view' page.
     * @return mixed
     */

	public function actionCreate()
	{
        $model = new \app\models\CallRequest();
		$model->scenario = 'create';
		
		if(Yii::$app->request->post()==array())
		{
			return $this->renderPartial('m_create', [
				'model' => $model,
				'title' => 'Create Call Request',
			]);
		}
		
		// сохранение
        if($model->load(Yii::$app->request->post()) && $model->validate() && $model->save() /*&& $model->contact(Yii::$app->params['adminEmail'])/**/) 
		{
			$responsible_user = ArrayHelper::getValue(Yii::$app->request->post(), 'CallRequest.responsible_user', array());
			if (!is_array($responsible_user)) $responsible_user = [$responsible_user];
			$model->setResponsibleUsers($responsible_user);
			
            $result=[
				'result'=>true,
				'msg'=>'Сохранено'// . print_r(Yii::$app->request->post('CallRequest')['responsible_user'],1)
			];
            return json_encode($result);
        }
		// если сохранение не удалось или не прошла проверка
        else
        {
            $result=[
				'result'=>false,
				'content'=> $this->renderPartial(
					'm_create', [
						'model' => $model,
						'title' => 'Create Call Request',
					]
				),
				'msg'=>'Ошибка'
			];
            return json_encode($result);			
        }
    }

    /**
     * Updates an existing CallRequest model.
     * If update is successful, the browser will be redirected to the 'view' page.
     * @param integer $id
     * @return mixed
     */
    public function actionUpdate($id)
    {
		$model = $this->findModel($id);
		if(Yii::$app->request->post()==array())
		{
			return $this->renderPartial('m_create', [
				'model' => $model,
				'title' => 'Update Call Request',
			]);
		}
		
		$model->scenario = 'update';
		// сохранение
        if($model->load(Yii::$app->request->post()) && $model->validate() && $model->canEdit() && $model->save()) 
		{
            $result=[
				'result'=>true,
				'msg'=>'Сохранено'// . print_r(Yii::$app->request->post('CallRequest')['responsible_user'],1)
			];
            return json_encode($result);
        }
		// если сохранение не удалось или не прошла проверка
        else
        {
            $result=[
				'result'=>false,
				'content'=> $this->renderPartial(
					'm_create', [
						'model' => $model,
						'title' => 'Update Call Request',
					]
				),
				'msg'=>'Ошибка' //. print_r($rr,1)
			];
            return json_encode($result);
        }
    }

    public function actionViewPosibleDependency($id)
    {
		$a_dependency = CallRequest::getPosibleDependencyAddress($id);
		foreach ($a_dependency as &$rec)
		{
			$rec->text = "<div class = \"col-sm-9\"><div>{$rec->address}</div><div>{$rec->comment}</div></div>";
		}
		unset($rec);
		$a_address_history = [];
		
		$a_address_history = CallRequest::find($id)->where(['address_id'=>$id])->all();
		
		return $this->renderPartial('m_posible_dependency', [
			'a_dependency' => $a_dependency,
			'a_address_history' => $a_address_history,
			'title' => 'Зависимость от аварии',
		]);
	}
	
    public function actionDone($id)
    {
		$model = $this->findModel($id);
		if(Yii::$app->request->post()==array())
		{
			return $this->renderPartial('done', [
				'model' => $this->findModel($id),
			]);
		}
		else
		if($model->canEdit())
		{
			$post = Yii::$app->request->post('CallRequest');
			$model->comment_done = ArrayHelper::getValue(Yii::$app->request->post(), 'CallRequest.comment_done', null);
			$model->comment_done = ArrayHelper::getValue(Yii::$app->request->post(), 'CallRequest.comment_done', null);
			$model->time_performed = ArrayHelper::getValue(Yii::$app->request->post(), 'CallRequest.time_performed', null);
			$responsible_user = ArrayHelper::getValue(Yii::$app->request->post(), 'CallRequest.responsible_user', array());
			if (!is_array($responsible_user))
				$responsible_user = [$responsible_user];
			if (implode($responsible_user,'') == '')
				$responsible_user[] = Yii::$app->user->getId();
			$model->scenario = 'done';
			if($model->validate() && $model->save())
			{
				if(Yii::$app->user->can('operator')){
					$model->setResponsibleUsers($responsible_user);
				}
				else
				{
					$model->setResponsibleUser(Yii::$app->user->getId());
				}
				$result=[
					'result'=>true,
					'content'=> $this->renderPartial(
						'done', ['model' => $model]
					),
					'msg'=>'Выполнено'
				];
				return json_encode($result);
			}
			else
			{
				$result=[
					'result'=>!true,
					'content'=> $this->renderPartial(
						'done', ['model' => $model]
					),
					'msg'=>'Ошибка ' . implode($model->getErrors('closed'), ', ')
				];
				return json_encode($result);		
			}
		}
    }

    /**
     * Deletes an existing CallRequest model.
     * If deletion is successful, the browser will be redirected to the 'index' page.
     * @param integer $id
     * @return mixed
     */
    public function actionDelete($id)
    {
        $this->findModel($id)->delete();

        return $this->redirect(['index']);
    }

    /**
     * Finds the CallRequest model based on its primary key value.
     * If the model is not found, a 404 HTTP exception will be thrown.
     * @param integer $id
     * @return CallRequest the loaded model
     * @throws NotFoundHttpException if the model cannot be found
     */
    protected function findModel($id)
    {
        if (($model = CallRequest::findOne($id)) !== null) {
            return $model;
        } else {
            throw new NotFoundHttpException('The requested page does not exist.');
        }
    }
	
    public function actionGetaddrinp($id = 0)
    {
		$uu = Yii::$app->request->post();
        $temp = SearchAddress::find()->where(['parent_id' => $id])->orderBy('name')->all();
		array_unshift($temp, ['id'=>0, 'name'=>Yii::t('app', '-select-')]);
        $temp = ArrayHelper::map($temp, 'id', 'name');
        $result =  Html::dropDownList('my-select', NULL, $temp, $options = []); /**/
        return $result;
    }

    public function renderAddrinp($id = 0)
    {
        $temp = SearchAddress::find()->where(['parent_id' => $id])->all();
		array_unshift($temp, ['id'=>0, 'name'=>Yii::t('app', '-select-')]);
        $temp = ArrayHelper::map($temp, 'id', 'name');
		$result =  Html::dropDownList('my-select', NULL, $temp, $options = []);
	}
	
    public function actionGetaddrinp2($id = 0)
    {

backend/views/request/_search.php
<?php

use yii\helpers\Html;
use yii\widgets\ActiveForm;

/* @var $this yii\web\View */
/* @var $model backend\controllers\RequestSearch */
/* @var $form yii\widgets\ActiveForm */
?>

<div class="call-request-search">

    <?php $form = ActiveForm::begin([
        'action' => ['index'],
        'method' => 'get',
    ]); ?>

    <?= $form->field($model, 'id') ?>

	<?= $form->field($model, 'time_add_min') ?>
    <?= $form->field($model, 'time_add') ?>

    <?= $form->field($model, 'time_performed') ?>

    <?= $form->field($model, 'type') ?>

    <?= $form->field($model, 'address') ?>

    <?php // echo $form->field($model, 'phone') ?>

    <?php // echo $form->field($model, 'contact') ?>

    <?php // echo $form->field($model, 'comment') ?>

    <?php // echo $form->field($model, 'status') ?>

    <?php // echo $form->field($model, 'responsible_user') ?>

    <div class="form-group">
        <?= Html::submitButton(Yii::t('app', 'Search'), ['class' => 'btn btn-primary']) ?>
        <?= Html::resetButton(Yii::t('app', 'Reset'), ['class' => 'btn btn-default']) ?>
    </div>

    <?php ActiveForm::end(); ?>

</div>

backend/views/request/create.php
<?php

use yii\helpers\Html;


/* @var $this yii\web\View */
/* @var $model app\models\CallRequest */

$this->title = Yii::t('app', 'Create Call Request');
$this->params['breadcrumbs'][] = ['label' => Yii::t('app', 'Call Requests'), 'url' => ['index']];
$this->params['breadcrumbs'][] = $this->title;
?>
<div class="call-request-create">

    <h1><?= Html::encode($this->title) ?></h1>

    <?= $this->render('_form', [
        'model' => $model,
    ]) ?>

</div>

backend/views/request/done.php
<?php

use yii\helpers\Html;
use yii\widgets\DetailView;
use yii\widgets\ActiveForm;

/* @var $this yii\web\View */
/* @var $model app\models\CallRequest */

$this->title = Yii::t('app', 'Done Request') . ' #' . $model->id;
$this->params['breadcrumbs'][] = ['label' => Yii::t('app', 'Call Requests'), 'url' => ['index']];
$this->params['breadcrumbs'][] = $this->title;
?>
<div class="modal-header">
	<button type="button" class="close" data-dismiss="modal">
		<span aria-hidden="true">&times;</span><span class="sr-only"><?Yii::t('app', 'Close')?></span>
	</button>
	<h4 class="modal-title"><?= Html::encode($this->title) ?></h4>
</div>

<div class="j_msg"> </div> <!-- For message -->
<?$disabled_class = (!$model->canEdit()) ? 'disabled_form' : ''?>
<?php $form = ActiveForm::begin(['options' => ['class' => 'request_done_form '.$disabled_class]]); ?>
<div class="modal-body">
	<div class="call-request-view">
		<?= DetailView::widget([
			'model' => $model,
			'attributes' => [
				'id',
				'time_add',
				'time_performed',
				[
					'attribute' => 'type',
					'value' => @\backend\models\CallType::find()->where(['id'=>$model->type])->one()['name'],
				],
				'time_expected_start',
				'time_expected_end',
				'address',
				'phone',
				'contact',
				'phone1',
				'contact1',
				'comment:ntext',
				//'responsible_user',
			],
		]) ?>
	</div>
	<?if($model->canClose()){?>
		<div class="row">
			<div class="<?if(Yii::$app->user->can('operator')){?>col-md-6<?}else{?>col-md-12<?}?>">
				<?=\Yii::$app->controller->renderPartial('inp_datetimepicker', ['m'=>$form->field($model, 'time_performed')->textInput(['class' => 'form-control'])]);?>
				<?= $form->field($model, 'comment_done')->textarea(['rows' => 3]) ?>
			</div>
		
		<?if(Yii::$app->user->can('operator')){?>
			<div class="col-md-6">
			<?= $form->field($model, 'responsible_user')->checkBoxList(\backend\models\User::getAllItems(), ['maxlength' => 25, 'size'=>'1']) ?>
			</div>
		<?}?>
		</div>
	<?}?>	
</div>
<div class="modal-footer">
<?if($model->canClose()){?>
	<?if($model->canEdit()){?>
	<?//var_dump($mx=$model->canEdit())?>
		<?= Html::submitButton(Yii::t('app', 'Done'), ['class' => 'btn btn-primary j_btn_done']) ?>
	<?}else{?>
		<button type="button" class="btn btn-default" data-dismiss="modal">Закрыть</button><?/**/?>
	<?}?>
<?}else{?>
	<h3>В заявке есть незакрытые подзаявки</h3>
<?}?>
	<?//<button type="button" class="btn btn-default" data-dismiss="modal">Закрыть</button><?/**/?>
</div>
<?php ActiveForm::end(); ?>

backend/views/request/index.php
<?php

use yii\helpers\Html;

/* @var $this yii\web\View */
/* @var $searchModel backend\controllers\RequestSearch */
/* @var $dataProvider yii\data\ActiveDataProvider */

$this->title = Yii::t('app', 'Call Requests');
$this->params['breadcrumbs'][] = $this->title;
?>
<div class="call-request-index">
    <h1><?= Html::encode($this->title) ?></h1>
    <p>
		<?if(Yii::$app->user->can('request_create')){?>
			<?= Html::a(Yii::t('app', 'Create Call Request'), ['create'], ['class' => 'btn btn-success signup', 'id' => 'j_create_request']) ?>
		<?}?>
    </p>

	<div class="table-responsive">
		<?= $this->render('sub_crash_tr', [
            'searchModel' => $searchModel,
            'dataProvider' => $dataProvider,
        ]);?>
	</div>

</div>

backend/views/request/inp_datetimepicker.php
<?php if (empty($class)) $class = 'j_datetimepicker'; ?>
<div class="input-group date <?= $class ?>">
    <?= $m ?>
    <span class="input-group-addon">
	<span class="glyphicon glyphicon-calendar"></span>
	</span>
</div>

backend/views/request/m_create.php
<?php

use yii\helpers\Html;
use yii\widgets\ActiveForm;

/* @var $this yii\web\View */
/* @var $model app\models\CallRequest */

$this->title = Yii::t('app', $title) . ' #' . $model->id;
$this->params['breadcrumbs'][] = ['label' => Yii::t('app', 'Call Requests'), 'url' => ['index']];
$this->params['breadcrumbs'][] = $this->title;
?>
<div class="modal-header">
	<button type="button" class="close" data-dismiss="modal">
		<span aria-hidden="true">&times;</span><span class="sr-only"><?Yii::t('app', 'Close')?></span>
	</button>
	<h4 class="modal-title"><?= Html::encode($this->title) ?></h4>
</div>
<div class="j_msg"> </div> <!-- For message -->
<?= $this->render('_m_form', [
	'model' => $model,
]) ?>

backend/views/request/sub_crash_tr.php
<?php

/** @var yii\data\ActiveDataProvider $dataProvider */

/** @var backend\controllers\RequestSearch $searchModel */

use backend\models\CallType;
use backend\models\User;
use kartik\export\ExportMenu;
use kartik\grid\GridView;
use yii\helpers\ArrayHelper;
use yii\helpers\Html;
use yii\helpers\Url;

$only_rec = !empty($only_rec);

$aa = [];
if ($only_rec) {
    $aa = [
        'layout' => '{items}',
        'showHeader' => false,
    ];
}

$columns = [
    //['class' => 'yii\grid\SerialColumn'],
    //['class' => 'yii\grid\CheckboxColumn'],
    [
        'class' => 'app\widgets\ExColumn',
        'type' => 'btn',
        'value' => function ($model) {
            if ($model->crash_id !== null)
                return '<span style="color:#C88; font-size:22px; vertical-align:midle;" class="glyphicon glyphicon-exclamation-sign text-center"></span>';
            else
                return '';
        },
        'format' => 'raw',
        'contentOptions' => function ($model, $key, $index, $cell) {
            $class = 'col_al_center';
            return ['class' => $class];
        },
    ],
    [
        'attribute' => 'id',
        'class' => 'app\widgets\ExColumn',
        'contentOptions' => function ($model, $key, $index, $cell) {
            $class = 'id_col color_rec_' . $model->type;
            if ($model->type == 1) $class .= ' cel_crash';
            return [
                'class' => $class
            ];
            return ['class' => $class];
        },
        'filterInputOptions' => ['class' => 'form-control id_src_inp'],
    ],
    [
        'class' => 'app\widgets\ExColumn',
        'type' => 'sel_radio',
        'attribute' => 'type',
        'filter' => ArrayHelper::map(CallType::find()->all(), 'id', 'name'),
        'filterInputOptions' => [
            'class' => 'form-control-ym',
            'id' => null
        ],
        'value' => function ($model) {
            return implode($model->getTypesNames(), ', ');
        },
    ],
    [
        'attribute' => 'time_add',
        'attribute_min' => 'time_add_min',
        'attribute_max' => 'time_add_max',

        'class' => 'app\widgets\ExColumn',
        'filter' => true,

        'type' => 'range',
        'value' => function ($data) {
            //return date("Y-m-d H", strtotime($data->time_add));
            return $data->time_add;
        },
    ],
    [
        'attribute' => 'time_expected_start',

        'attribute_min' => 'time_expected_start_min',
        'attribute_max' => 'time_expected_start_max',

        'class' => 'app\widgets\ExColumn',
        'filter' => true,
        'type' => 'range',

        'value' => function ($data) {
            $a_str = [$data->time_expected_start];
            if (!empty($data->time_expected_hh_end)) {
                $a_str[] = '&ndash;';
                $a_str[] = $data->time_expected_hh_end;
            }
            return implode($a_str, '');
        },
        'format' => 'raw',
    ],
    [
        'attribute' => 'time_performed',
        'attribute_min' => 'time_performed_min',
        'attribute_max' => 'time_performed_max',
        'class' => 'app\widgets\ExColumn',
        'filter' => true,
        'type' => 'range',
        'value' => function ($data) {
            if ($data->time_performed)
                return date("Y-m-d H", strtotime($data->time_performed));
            else
                return null;
        },
    ],
    [
        'attribute' => 'address',
        'value' => function ($data) {
            return /*$data->address_id. ' | ' ./**/ $data->address;
        }
    ],
    [
        'attribute' => 'phone',
        'value' => function ($data) {
            return implode([$data->phone, $data->phone1], ' ');
        }
    ],
    [
        'attribute' => 'contact',
        'value' => function ($data) {
            return implode([$data->contact, $data->contact1], ' ');
        }
    ],
    [
        'attribute' => 'comment',
        'value' => function ($data) {
            return iconv_substr($data->comment, 0, 20, 'UTF8');
        },
    ],
    //'comment:ntext',
    [
        'attribute' => 'responsible_user',
        'filter' => ArrayHelper::map(User::find()->all(), 'id', 'userfullname'),
        'filterInputOptions' => [
            'class' => 'form-control-ym',
            'id' => null
        ],
        'value' => function ($data) {
            $responsible_user_info = ArrayHelper::map($data->responsible_user_info, 'id', 'userfullname');
            return implode((array)$responsible_user_info, ', ');
        },
        'format' => 'raw',
    ],
    [
        'class' => 'app\widgets\ActionColumn',
        'type' => 'hbtn',
        'template' => '<p style="white-space: nowrap;">{update} {view} {done}</p>',
        'buttons' => [
            'update' => function ($url, $model) {
                if (!Yii::$app->user->can('request_edit')) return;
                $url = Url::toRoute(['/request/update', 'id' => $model->id]);
                return Html::a('<span class="glyphicon glyphicon-pencil"></span>', $url, [
                    'title' => 'Редактирование',
                    'data-pjax' => '0',            // отключение стандартного обработчика pjax. Он все портит:)
                    'class' => 'j_edit_request'    // ссылке класс:)
                ]);
            },
            'view' => function ($url, $model) {
                if (!Yii::$app->user->can('request_view')) return;
                $url = Url::toRoute(['/request/view', 'id' => $model->id]);
                return Html::a('<span class="glyphicon glyphicon-eye-open"></span>', $url, [
                    'title' => 'Просмотр',
                    'data-pjax' => '0',
                    'class' => 'j_view_request'
                ]);
            },
            'done' => function ($url, $model) {
                if (!Yii::$app->user->can('request_done')) return;
                $url = Url::toRoute(['/request/done', 'id' => $model->id]);
                return Html::a('<span class="glyphicon glyphicon-ok"></span>', $url, [
                    'title' => 'Закрытие',
                    'data-pjax' => '0',
                    'class' => 'j_done_request'
                ]);
            },
        ],

    ]
];
echo '<div class="pull-right">';
echo ExportMenu::widget([
    'dataProvider' => $dataProvider,
    'columns' => $columns,
    'pjax' => false,
    'dropdownOptions' => [
        'label' => 'Export All',
        'class' => 'btn btn-outline-secondary'
    ],
    'exportConfig' => [
        ExportMenu::FORMAT_HTML => false,
        ExportMenu::FORMAT_EXCEL => false,
        ExportMenu::FORMAT_TEXT => false,
        ExportMenu::FORMAT_CSV => [
            'label' => Yii::t('app', 'CSV'),
        ],
        ExportMenu::FORMAT_EXCEL_X => false,
    ],
]);
echo '</div>';
echo '<br>';

echo GridView::widget($aa + [
        'dataProvider' => $dataProvider,
        'filterModel' => $searchModel,
        'pjax' => false,
        'pjaxSettings' => [
            'options' => [
                'id' => 'requests'
            ]
        ],
        'rowOptions' => function ($model, $key, $index, $grid) {
            if ($model->time_expected_end) {

            }
            $class = 'color_rec_' . $model->type;
            if ($model->type == 1) $class .= ' rec_crash';
            if (((strtotime($model->time_expected_start . ':00:00') - time()) / 60 / 60 < 1)
                and (strtotime($model->time_expected_end . ':00:00') - time() > 0)
                and ($model->time_performed == null))
                $class .= ' caution';
            if (!empty($model->time_expected_end))
                if (((strtotime($model->time_expected_end . ':00:00') - time() < 0) and ($model->time_performed == null))
                    or (strtotime($model->time_expected_end . ':00:00') - strtotime($model->time_performed) < 0))
                    $class .= ' overdue';

            return [
                'class' => $class,
            ];
        },
        'columns' => $columns
    ]
);

backend/views/request/update.php
<?php

use yii\helpers\Html;

/* @var $this yii\web\View */
/* @var $model app\models\CallRequest */

$this->title = Yii::t('app', 'Update {modelClass}: ', [
    'modelClass' => 'Call Request',
]) . ' ' . $model->id;
$this->params['breadcrumbs'][] = ['label' => Yii::t('app', 'Call Requests'), 'url' => ['index']];
$this->params['breadcrumbs'][] = ['label' => $model->id, 'url' => ['view', 'id' => $model->id]];
$this->params['breadcrumbs'][] = Yii::t('app', 'Update');
?>
<div class="call-request-update">

    <h1><?= Html::encode($this->title) ?></h1>

    <?= $this->render('_form', [
        'model' => $model,
    ]) ?>

</div>